"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tab = tab;

var _dom = require("@testing-library/dom");

var _utils = require("./utils");

function tab({
  shift = false,
  focusTrap
} = {}) {
  var _focusTrap$ownerDocum, _focusTrap;

  const doc = (_focusTrap$ownerDocum = (_focusTrap = focusTrap) == null ? void 0 : _focusTrap.ownerDocument) != null ? _focusTrap$ownerDocum : document;
  const previousElement = (0, _utils.getActiveElement)(doc); // Never the case in our test environment
  // Only happens if the activeElement is inside a shadowRoot that is not part of `doc`.

  /* istanbul ignore next */

  if (!previousElement) {
    return;
  }

  if (!focusTrap) {
    focusTrap = doc;
  }

  const nextElement = (0, _utils.getTabDestination)(previousElement, shift, focusTrap);
  const shiftKeyInit = {
    key: 'Shift',
    keyCode: 16,
    shiftKey: true
  };
  const tabKeyInit = {
    key: 'Tab',
    keyCode: 9,
    shiftKey: shift
  };
  let continueToTab = true;
  if (shift) _dom.fireEvent.keyDown(previousElement, { ...shiftKeyInit
  });
  continueToTab = _dom.fireEvent.keyDown(previousElement, { ...tabKeyInit
  });
  const keyUpTarget = continueToTab ? nextElement : previousElement;

  if (continueToTab) {
    if (nextElement === doc.body) {
      (0, _utils.blur)(previousElement);
    } else {
      (0, _utils.focus)(nextElement);
    }
  }

  _dom.fireEvent.keyUp(keyUpTarget, { ...tabKeyInit
  });

  if (shift) {
    _dom.fireEvent.keyUp(keyUpTarget, { ...shiftKeyInit,
      shiftKey: false
    });
  }
}